2013-07-05 11:53:09Morris

[UVA][二分] 12097 - Pie

Problem C - Pie

Time limit: 1 second

My birthday is coming up and traditionally I'm serving pie. Not just one pie, no, I have a number N of them, of various tastes and of various sizes. F of my friends are coming to my party and each of them gets a piece of pie. This should be one piece of one pie, not several small pieces since that looks messy. This piece can be one whole pie though.

My friends are very annoying and if one of them gets a bigger piece than the others, they start complaining. Therefore all of them should get equally sized (but not necessarily equally shaped) pieces, even if this leads to some pie getting spoiled (which is better than spoiling the party). Of course, I want a piece of pie for myself too, and that piece should also be of the same size.

What is the largest possible piece size all of us can get? All the pies are cylindrical in shape and they all have the same height 1, but the radii of the pies can be different.

Input

One line with a positive integer: the number of test cases. Then for each test case:

  • One line with two integers N and F with 1 ≤ N, F ≤ 10000: the number of pies and the number of friends.
  • One line with N integers ri with 1 ≤ ri ≤ 10000: the radii of the pies.

Output

For each test case, output one line with the largest possible volume V such that me and my friends can all get a pie piece of size V. The answer should be given as a floating point number with an absolute error of at most 10-3.

Sample Input

3
3 3
4 3 3
1 24
5
10 5
1 4 2 3 4 5 6 5 4 2

Sample Output

25.1327
3.1416
50.2655
The 2006 ACM Northwestern European Programming Contest

題目描述:

現在有一些不同半徑的蛋糕,每個厚度都是 1,現在有 F 個朋友和自己要去分,
而每個人所得到的蛋糕塊的體積要一樣,但分的時候只能來自於一塊蛋糕,
不可由來自不同蛋糕的小蛋糕構成。

題目解法:


二分答案,然後去除每塊蛋糕取整數,得到該蛋糕可以分出幾份。

#include <stdio.h>
#include <math.h>
#include <algorithm>
using namespace std;
double v[10005];
const double pi = acos(-1);
int r[10005];
int check(int N, int F, double c) {
    static int i, cut;
    for(i = 0, cut = 0; i < N; i++) {
        cut += (int)(v[i]/c);
        if(cut >= F)    return 1;
    }
    return 0;
}
int main() {
    int testcase;
    int N, F;
    int i, j, k;
    scanf("%d", &testcase);
    while(testcase--) {
        scanf("%d %d", &N, &F);
        F++;
        for(i = 0; i < N; i++)
            scanf("%d", &r[i]);
        double sum = 0;
        for(i = 0; i < N; i++) {
            v[i] = r[i]*r[i]*pi;
            sum += v[i];
        }
        double l = 0, r = sum/F, m;
#define eps 1e-4
        int flag, cnt = 0;
        while(fabs(l-r) > eps) {
            m = (l+r)/2;
            flag = check(N, F, m);
            if(flag == 0)   r = m;
            else            l = m;
        }
        printf("%.4lf\n", m);
    }
    return 0;
}